Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# ACE_Free_List< T > Class Template Reference

Implements a free list. More...

`#include <Free_List.h>`

Inheritance diagram for ACE_Free_List< T >:

[legend]
List of all members.

## Public Member Functions
virtual | ~ACE_Free_List (void)
| Destructor - removes all the elements from the free_list.
virtual void | add (T *element)=0
virtual T * | remove (void)=0
virtual size_t | size (void)=0
| Returns the current size of the free list.
virtual void | resize (size_t newsize)=0
| Resizes the free list to <newsize>.

## Detailed Description

### template<class T>
class ACE_Free_List< T >

Implements a free list.

This class maintains a free list of nodes of type T.

## Constructor & Destructor Documentation

template<class T>
ACE_BEGIN_VERSIONED_NAMESPACE_DECL ACE_Free_List< T >::~ACE_Free_List | ( | void |  | ) | `[virtual]`

| Destructor - removes all the elements from the free_list.

## Member Function Documentation

template<class T>
virtual void ACE_Free_List< T >::add | ( | T * | element | ) | `[pure virtual]`

| Inserts an element onto the free list (if it isn't past the high water mark). Implemented in ACE_Locked_Free_List< T, ACE_LOCK >, ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< char >, ACE_LOCK >, ACE_Locked_Free_List< ACE_Thread_Descriptor, ACE_SYNCH_MUTEX >, and ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< T >, ACE_LOCK >.

template<class T>
virtual T* ACE_Free_List< T >::remove | ( | void |  | ) | `[pure virtual]`

| Takes a element off the freelist and returns it. It creates <inc> new elements if the size is at or below the low water mark. Implemented in ACE_Locked_Free_List< T, ACE_LOCK >, ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< char >, ACE_LOCK >, ACE_Locked_Free_List< ACE_Thread_Descriptor, ACE_SYNCH_MUTEX >, and ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< T >, ACE_LOCK >.

template<class T>
virtual void ACE_Free_List< T >::resize | ( | size_t | newsize | ) | `[pure virtual]`

| Resizes the free list to <newsize>. Implemented in ACE_Locked_Free_List< T, ACE_LOCK >, ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< char >, ACE_LOCK >, ACE_Locked_Free_List< ACE_Thread_Descriptor, ACE_SYNCH_MUTEX >, and ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< T >, ACE_LOCK >.

template<class T>
virtual size_t ACE_Free_List< T >::size | ( | void |  | ) | `[pure virtual]`

| Returns the current size of the free list. Implemented in ACE_Locked_Free_List< T, ACE_LOCK >, ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< char >, ACE_LOCK >, ACE_Locked_Free_List< ACE_Thread_Descriptor, ACE_SYNCH_MUTEX >, and ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< T >, ACE_LOCK >.

The documentation for this class was generated from the following files:

- Free_List.h
- Free_List.cpp